\Ellipse.xpl	5-Mar-2012
inc	c:\cxpl\codesi;			\intrinsic 'code' declarations

def	W=640, H=480;			\screen width and height
def	Xc=W/2, Yc=H/2;			\center coordinates of screen
def	Black, Blue, Green, Cyan, Red, Magenta, Brown, White,	\EGA colors
	Gray, LBlue, LGreen, LCyan, LRed, LMagenta, Yellow, BWhite;


proc	DrawDot(X, Y, C);		\Draw a colored 3x3 dot at X,Y
real	X, Y;
int	C;
int	I, J;
begin
for J:= -1, 1 do
    for I:= -1, 1 do
	Point(Fix(X)+Xc+I, Fix(Y)+Yc+J, C);
end;	\DrawDot


proc	DrawLine(X0, Y0, X1, Y1, C);	\Draw a colored line from X0,Y0 to X1,Y1
real	X0, Y0, X1, Y1;
int	C;
begin
Move(Fix(X0)+Xc, Fix(Y0)+Yc);
Line(Fix(X1)+Xc, Fix(Y1)+Yc, C);
end;	\DrawLine


def	D=100.0, L=100.0;		\lengths of line segments (pixels)
real	T, Px, Py, Py0, Qx, Qy, Rx, Ry;	\coordinates of points P, Q, R (etc.)

begin	\Main
SetVid($12);				\VGA graphics: 640x480 x16 colors
DrawLine(-L-D, 0.0, L+D, 0.0, Blue);	\X and Y axes
DrawLine(0.0,   -D, 0.0,   D, Blue);

T:= 0.0;				\initialize angle Theta
Px:= 0.0;				\end points of P-Q segment are on axes
Qy:= 0.0;
Py0:= 0.0;				\used to detect movement direction
loop	begin
	Py:= D*Sin(T);			\drive point P up and down
	Qx:= Sqrt(D*D - Py*Py);		\point Q moves along X axis because of P
	if Py-Py0 >= 0.0 then Qx:= -Qx;	\required to rotate the full 360 degrees
	Py0:= Py;
	Rx:= Qx*(L+D)/D;		\project point R to trace the ellipse
	Ry:= -Py*L/D;

	DrawLine(Px, Py, Qx, Qy, LRed+$80);	\XOR lines are easy to erase
	DrawLine(Qx, Qy, Rx, Ry, LGreen+$80);
	DrawDot(Px, Py, BWhite+$80);	\show end points of line segments
	DrawDot(Qx, Qy, BWhite+$80);
	DrawDot(Rx, Ry, BWhite+$80);

	Sound(0, 1, 1);			\delay about 1/18 second

	DrawDot(Rx, Ry, BWhite+$80);	\erase the dots and lines
	DrawDot(Qx, Qy, BWhite+$80);
	DrawDot(Px, Py, BWhite+$80);
	DrawLine(Qx, Qy, Rx, Ry, LGreen+$80);
	DrawLine(Px, Py, Qx, Qy, LRed+$80);
	DrawDot(Rx, Ry, BWhite);	\leave dots to trace an ellipse

	if ChkKey then quit;		\any keystroke terminates program
	T:= T + 0.03;			\increment angle (determines speed)
	end;

Setvid(03);				\restore text mode for DOS prompt C:\
end;	\Main
